﻿Public Class Form1
    Private _InvoiceType As String = "Warenausgang"
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Using dlg As New PrintPreviewDialog
            Me.PrintDocument1.DocumentName = "Test"   ' Arbeitstitel
            dlg.WindowState = FormWindowState.Maximized
            dlg.Document = Me.PrintDocument1
            dlg.ShowDialog()
        End Using
    End Sub

    Private Sub CreateInvoice(sender As Object, e As Printing.PrintPageEventArgs)
        Dim CompanyFirstInfo As New List(Of String)
        Dim CompanySecondInfo As New List(Of String)
        Dim CustomerFirstInfo As New List(Of String)
        Dim CustomerSecondInfo As New List(Of String)
        Dim Invoicetype As String = ""
        Dim Invoicetext As String = ""
        Dim Invoicedate As New List(Of String)
        Dim ArticleList As New List(Of String)
        Dim Net7 As Double = 0
        Dim Net19 As Double = 0
        Dim NetTotal As Double = 0
        Dim Tax7 As Double = 0
        Dim Tax19 As Double = 0
        Dim BrutTotal As Double = 0
        Dim ShowNetSums As Boolean = True

        Invoicedate.Add("Datum: " & System.DateTime.Now.ToString("dd.MM.yyyy"))
        Net7 = 7.0
        Net19 = 19
        NetTotal = Net7 + Net19
        Tax7 = 0.07
        Tax19 = 0.19
        BrutTotal = Net7 + Net19 + Tax7 + Tax19

        Select Case _InvoiceType
            Case = "Warenausgang"
                CompanyFirstInfo.Add("Firmenname1")
                CompanyFirstInfo.Add("Firmenname2")
                CompanyFirstInfo.Add("Firmenstraße")
                CompanyFirstInfo.Add("Firmenort")
                CompanySecondInfo.Add("Firmentelefon")
                CompanySecondInfo.Add("Firmenmail")
                CompanySecondInfo.Add("Firmensteuernr")
                CustomerFirstInfo.Add("KundenFirma")
                CustomerFirstInfo.Add("Kundenname")
                CustomerFirstInfo.Add("Kundenstr.")
                CustomerFirstInfo.Add("Kundenort")
                CustomerSecondInfo.Add("KundenTelefon")
                Invoicedate.Add("Rechnungdatum entspricht Leistungsdatum")
                Invoicetype = "Rechnung"
                Invoicetext = "Wir danken für Ihren Einkauf und berechnen wie folgt:"
                ArticleList = GetArticle()
                'Case = "Wareneingang"
                '    If Not CheckCustomerData() Then Return
                '    CompanyFirstInfo = GetCustomerFirstData()
                '    CompanySecondInfo = GetCustomerSecondData()
                '    CustomerFirstInfo = GetCompanyFirstData()
                '    CustomerSecondInfo = GetCompanySecondData()
                '    Invoicedate.Add("Rechnungdatum entspricht Leistungsdatum")
                '    Invoicetype = "Rechnung"
                '    Invoicetext = ""
                '    ArticleList = GetArticle(False)
                '    ShowNetSums = False
                'Case = "Artikelrückgabe"
                '    If Not CheckCustomerData() Then Return
                '    CompanyFirstInfo = GetCompanyFirstData()
                '    CompanySecondInfo = GetCompanySecondData()
                '    CustomerFirstInfo = GetCustomerFirstData()
                '    CustomerSecondInfo = GetCustomerSecondData()
                '    Invoicedate.Add("Rechnungdatum entspricht Leistungsdatum")
                '    Invoicetype = "Artikelrückgabe"
                '    Invoicetext = ""
                '    ArticleList = GetArticle(False)
                'Case = "Angebot"
                '    CompanyFirstInfo = GetCompanyFirstData()
                '    CompanySecondInfo = GetCompanySecondData()
                '    CustomerFirstInfo = GetCustomerFirstData()
                '    CustomerSecondInfo = GetCustomerSecondData()
                '    Invoicedate.Add("")
                '    Invoicetype = "Angebot"
                '    Invoicetext = "Gerne unterbreiten wir Ihnen hiermit folgendes Angebot." &
                '       Environment.NewLine & "Die angebotenen Preise sind freibleibend."
                '    ArticleList = GetArticle(_NetInvoicing)
        End Select

        DrawPdf(sender, e, CompanyFirstInfo, CompanySecondInfo, CustomerFirstInfo, CustomerSecondInfo, Invoicedate, Invoicetype, Invoicetext, ArticleList,
                Net7, Net19, NetTotal, Tax7, Tax19, BrutTotal, ShowNetSums)

    End Sub
    Private Function GetArticle() As List(Of String)
        Dim ArticleList As New List(Of String)
        Dim Article As String = ""
        For i = 1 To 5
            Article = "1" & "~" & "Art.Nr. " & i & "~" & "Artikelname " & i & "~" & "19" & "~"
            ArticleList.Add(Article)
        Next
        Return ArticleList
    End Function

    Private Sub DrawPdf(sender As Object, e As Printing.PrintPageEventArgs, Biller1 As List(Of String), Biller2 As List(Of String), Recipient1 As List(Of String),
                        recipient2 As List(Of String), Invoicedate As List(Of String), Invoicetype As String, Invoicetext As String, ArticleList As List(Of String),
                        Net7 As Double, Net19 As Double, NetTotal As Double, Tax7 As Double, tax19 As Double, Bruttotal As Double, ShowNetSums As Boolean)

        Dim xlinks As Integer = 100
        Dim xrechts As Integer = 500
        Dim y As Integer = 30
        Dim yStart As Integer = y

        Dim TextFont As Font = New Font("times new roman", 12)
        Dim HeaderFont As Font = New Font("times new roman", 18)

        'Ausstelleradresse der Rechnung - linke Seite
        For Each item In Biller1
            e.Graphics.DrawString(item, TextFont, Brushes.Black, New Point(xlinks, y))
            y += 20
        Next

        y = yStart

        'Ausstelleradresse der Rechnung - rechte Seite
        For Each item In Biller2
            e.Graphics.DrawString(item, TextFont, Brushes.Black, New Point(xrechts, y))
            y += 20
        Next

        y += 70
        yStart = y

        'Empfänger der Rechnung - linke Seite
        For Each item In Recipient1
            e.Graphics.DrawString(item, TextFont, Brushes.Black, New Point(xlinks, y))
            y += 20
        Next

        Dim yTemp = y + 50
        y = yStart

        'Empfänger der Rechnung - rechte Seite
        For Each item In recipient2
            e.Graphics.DrawString(item, TextFont, Brushes.Black, New Point(xrechts, y))
            y += 20
        Next

        y = yTemp

        'Rechnungsart
        e.Graphics.DrawString(Invoicetype, HeaderFont, Brushes.Black, New Point(xlinks, y))

        'Rechnungsdatum
        For Each item In Invoicedate
            e.Graphics.DrawString(item, TextFont, Brushes.Black, New Point(xrechts, y))
            y += 20
        Next

        y += 30

        'Rechnungstext
        e.Graphics.DrawString(Invoicetext, TextFont, Brushes.Black, New Point(xlinks, y))

        ''Artikeltabelle
        'Dim table As PdfTable = New PdfTable(_page, _contents, _font, 12.0)
        'table.TableArea = New PdfRectangle(Leftborder, 50, Leftborder + 170, 190) 'Left, Bottom, Right, Top
        'table.SetColumnWidth(15, 25, 60, 15, 25, 25)
        ''Ränder setzenW
        'table.Borders.SetFrame(0, Color.White)

        ''Cell Style ändern
        'table.DefaultCellStyle.Alignment = ContentAlignment.MiddleLeft
        'Dim centerstyle As PdfTableStyle = table.CellStyle
        'centerstyle.Alignment = ContentAlignment.MiddleCenter
        'Dim rightstyle As PdfTableStyle = table.CellStyle
        'rightstyle.Alignment = ContentAlignment.MiddleRight
        'Dim leftstyle As PdfTableStyle = table.CellStyle
        'leftstyle.Alignment = ContentAlignment.MiddleLeft
        'Dim MultiLineStyle As PdfTableStyle = table.CellStyle
        'MultiLineStyle.MultiLineText = True

        ''Zellen beschriften
        'table.Cell(0).Value = "Menge"
        'table.Cell(0).Style = centerstyle
        'table.Cell(1).Value = "Art. Nr."
        'table.Cell(1).Style = rightstyle
        'table.Cell(2).Value = "Name"
        'table.Cell(3).Value = "Mwst."
        'table.Cell(3).Style = centerstyle
        'table.Cell(4).Value = "Einzelpreis"
        'table.Cell(4).Style = rightstyle
        'table.Cell(5).Value = "Gesamtpreis"
        'table.Cell(5).Style = rightstyle
        'table.DrawRow()
        'table.Cell(0).Value = ""
        'table.DrawRow()
        'For Each article In ArticleList
        '    Dim Articleinfos() As String
        '    Articleinfos = article.Split("~"c)
        '    For i = 0 To Articleinfos.Count - 1
        '        table.Cell(i).Value = Articleinfos(i)
        '    Next
        '    table.Cell(0).Style = centerstyle
        '    table.Cell(1).Style = rightstyle
        '    table.Cell(2).Style = MultiLineStyle
        '    table.Cell(3).Style = centerstyle
        '    table.Cell(4).Style = rightstyle
        '    table.Cell(5).Style = rightstyle
        '    table.DrawRow()
        '    table.Cell(0).Value = ""
        '    table.DrawRow()
        'Next
        'Dim ColumnPosition = table.ColumnPosition
        'Dim PosY = table.RowTopPosition - 2 * 0.04 - table.DefaultCellStyle.FontAscent + 5
        '_contents.DrawLine(ColumnPosition(0), PosY, ColumnPosition(6), PosY)
        'table.DrawRow()
        'If ShowNetSums Then
        '    table.Cell(2).Value = "Netto - Betrag"
        '    table.Cell(2).Style = leftstyle
        '    table.Cell(5).Value = NetTotal.ToString("#,##0.00 €")
        '    table.DrawRow()
        '    table.DrawRow()

        '    If Net7 > 0 Then
        '        table.Cell(2).Value = "7% Mwst. auf"
        '        table.Cell(2).Style = rightstyle
        '        table.Cell(4).Value = Net7.ToString("#,##0.00 €")
        '        table.Cell(4).Style = rightstyle
        '        table.Cell(5).Value = Tax7.ToString("#,##0.00 €")
        '        table.DrawRow()
        '    End If
        '    If Net19 > 0 Then
        '        table.Cell(2).Value = "19% Mwst. auf"
        '        table.Cell(2).Style = rightstyle
        '        table.Cell(4).Value = Net19.ToString("#,##0.00 €")
        '        table.Cell(4).Style = rightstyle
        '        table.Cell(5).Value = tax19.ToString("#,##0.00 €")
        '        table.DrawRow()
        '    End If
        '    table.Cell(0).Value = ""
        '    table.DrawRow()
        '    ColumnPosition = table.ColumnPosition
        '    PosY = table.RowTopPosition - 2.0 * 0.04 - table.DefaultCellStyle.FontAscent + 5
        '    _contents.DrawLine(ColumnPosition(0), PosY, ColumnPosition(6), PosY)
        'End If
        'table.Cell(2).Value = "Endsumme"
        'table.Cell(2).Style = leftstyle
        'table.Cell(5).Value = Bruttotal.ToString("#,##0.00 €")
        'table.DrawRow()
        'table.Close()

        '_document.CreateFile()
        'Process.Start(Filename)

    End Sub

    Private Sub PrintDocument1_PrintPage(sender As Object, e As Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage
        CreateInvoice(sender, e)
    End Sub
End Class
